#ifndef __classConfiguration

#define __classConfiguration

#include <stddef.h>

#include <engine/opengl.h>

#include <engine/event.h>

#include <vector2.h>

#include <engine/vector.h>

#include <int.h>

#include <engine/quadMesh.h>

#include <engine/element.h>

#include <engine/vector4.h>

#include <engine/windowManager.h>

#include <engine/hints.h>

#include <engine/resourceManager.h>

#include <engine/texture2D.h>

#include <engine/renderPasses/renderPassTesselation.h>

#include <engine/mesh.h>

#include <engine/unsignedIntegerArray.h>

#include <engine/floatArray.h>

#include <engine/program.h>

#include <engine/shader.h>

#include <engine/sampler2D.h>

#include <vector3.h>

#include <array.h>

#include <text.h>

#include <char.h>

#include <fileSystem.h>

#include <console.h>

#include <http.h>

#include <headers.h>

#include <header.h>

#include <request.h>

#include <cache.h>

#include <file.h>

#include <mimeTypes.h>

#include <engine/uniform.h>

#include <engine/member.h>

#include <engine/block.h>

#include <engine/fontRenderer.h>

#include <engine/renderPasses/renderPass.h>

#include <engine/renderPasses/renderPassCompute2.h>

#include <engine/renderPasses/renderPassCompute.h>

#include <engine/renderPasses/renderPassFont.h>

#include <engine/renderPasses/renderPassQuads.h>

#include <engine/pipeline.h>

#include <engine/eventManager.h>

#define TOTAL_CLASS_COUNT 52

extern char * __ClassNames[TOTAL_CLASS_COUNT];
extern int __ClassPropertyCount[TOTAL_CLASS_COUNT];
extern char * __ClassPropertyNames[TOTAL_CLASS_COUNT][30];
extern int __ClassPropertyOffsets[TOTAL_CLASS_COUNT][30];
extern int __ClassPropertyOffsets[TOTAL_CLASS_COUNT][30];

#include <string.h>

int getPropertyIndexOfClassIndex( int propertyCount, char ** propertyNames );

void getArrayByClassIndex( int size, void * * voidArray, int * structByteSize, int classIndex );

int getClassIndexByClassName( char * className );

char * getClassName( int classIndex );

int getPropertyCountByClassIndex( int classIndex );

char * * getPropertiesByClassIndex( int classIndex );

int * getPropertyOffsetsByClassIndex( int classIndex );

int getPropertyOffsetByPropertyIndex( int * propertyOffsets, int propertyIndex );

int getPropertyIndexByPropertyName( int classID, char * propertyName );

int * getPropertyDatatypeIndexesByClassIndex( int classIndex );

int getPropertyDatatypeIndex( int * propertyDatatypeIndices, int propertyIndex );

int getMethodCountByClassIndex( int classIndex );

char * * getMethodNamesByClassIndex( int classIndex );


int getMethodIndexByPropertyName( int classID, char * propertyName );

void callMethodOfClass( int classIndex, int methodIndex, void * object );
#endif
